diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/mtd/devices/blkmtd.c linux-2.4.22-ashuariadevel/drivers/mtd/devices/blkmtd.c
*** linux-2.4.22-ashuariadevel.backup/drivers/mtd/devices/blkmtd.c	2003-06-13 23:51:34.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/mtd/devices/blkmtd.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 294,301 ****
  			iobuf->nr_pages--;
  			ignorepage = pagenr;
  		} else {
! 			DEBUG(3, "blkmtd: doing writeout pagenr = %d max_pagenr = %ld pagecnt = %d idx = %d\n",
! 			      pagenr, iobuf->blocks[iobuf->nr_pages-1],
  			      pagecnt, iobuf->nr_pages);
  			commit_pages(dev);
  		}
--- 294,302 ----
  			iobuf->nr_pages--;
  			ignorepage = pagenr;
  		} else {
! 			DEBUG(3, "blkmtd: doing writeout pagenr = %d max_pagenr = %llu pagecnt = %d idx = %d\n",
! 			      pagenr,
! 			      (unsigned long long)iobuf->blocks[iobuf->nr_pages-1],
  			      pagecnt, iobuf->nr_pages);
  			commit_pages(dev);
  		}
***************
*** 335,347 ****
  	/* Now do the main loop to a page aligned, n page sized output */
  	if(len) {
  		int pagesc = len >> PAGE_SHIFT;
! 		DEBUG(3, "blkmtd: write: whole pages start = %d, count = %d\n",
! 		      pagenr, pagesc);
  		while(pagesc) {
  			struct page *page;
  
  			/* see if page is in the page cache */
! 			DEBUG(3, "blkmtd: write: grabbing page %d from page cache\n", pagenr);
  			page = grab_cache_page(dev->binding->bd_inode->i_mapping, pagenr);
  			if(PageDirty(page) && pagenr != ignorepage) {
  				BUG();
--- 336,348 ----
  	/* Now do the main loop to a page aligned, n page sized output */
  	if(len) {
  		int pagesc = len >> PAGE_SHIFT;
! 		DEBUG(3, "blkmtd: write: whole pages start = %llu, count = %d\n",
! 		      (unsigned long long)pagenr, pagesc);
  		while(pagesc) {
  			struct page *page;
  
  			/* see if page is in the page cache */
! 			DEBUG(3, "blkmtd: write: grabbing page %llu from page cache\n", (unsigned long long)pagenr);
  			page = grab_cache_page(dev->binding->bd_inode->i_mapping, pagenr);
  			if(PageDirty(page) && pagenr != ignorepage) {
  				BUG();
***************
*** 652,661 ****
  				lru++;
  		}
  
! 		len += sprintf(page+len, "mtd%d:\t%ld\t%d\t%ld\t%d\t%d\t%d\t%d\n",
  			       dev->mtd_info.index,
  			       (dev->wr_buf && dev->wr_buf->nr_pages) ?
! 			       dev->wr_buf->blocks[dev->wr_buf->nr_pages-1] : 0,
  			       (dev->wr_buf) ? dev->wr_buf->nr_pages : 0,
  			       dev->binding->bd_inode->i_mapping->nrpages,
  			       clean, dirty, locked, lru);
--- 653,662 ----
  				lru++;
  		}
  
! 		len += sprintf(page+len, "mtd%d:\t%llu\t%d\t%ld\t%d\t%d\t%d\t%d\n",
  			       dev->mtd_info.index,
  			       (dev->wr_buf && dev->wr_buf->nr_pages) ?
! 			       (unsigned long long)dev->wr_buf->blocks[dev->wr_buf->nr_pages-1] : 0ULL,
  			       (dev->wr_buf) ? dev->wr_buf->nr_pages : 0,
  			       dev->binding->bd_inode->i_mapping->nrpages,
  			       clean, dirty, locked, lru);
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/mtd/ftl.c linux-2.4.22-ashuariadevel/drivers/mtd/ftl.c
*** linux-2.4.22-ashuariadevel.backup/drivers/mtd/ftl.c	2003-06-13 23:51:34.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/mtd/ftl.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 205,211 ****
  #define XFER_FAILED	0x04
  
  static struct hd_struct ftl_hd[MINOR_NR(MAX_DEV, 0, 0)];
! static int ftl_sizes[MINOR_NR(MAX_DEV, 0, 0)];
  static int ftl_blocksizes[MINOR_NR(MAX_DEV, 0, 0)];
  
  static struct gendisk ftl_gendisk = {
--- 205,211 ----
  #define XFER_FAILED	0x04
  
  static struct hd_struct ftl_hd[MINOR_NR(MAX_DEV, 0, 0)];
! static sector_t ftl_sizes[MINOR_NR(MAX_DEV, 0, 0)];
  static int ftl_blocksizes[MINOR_NR(MAX_DEV, 0, 0)];
  
  static struct gendisk ftl_gendisk = {
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/mtd/mtdblock.c linux-2.4.22-ashuariadevel/drivers/mtd/mtdblock.c
*** linux-2.4.22-ashuariadevel.backup/drivers/mtd/mtdblock.c	2003-12-09 11:52:13.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/mtd/mtdblock.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 57,63 ****
  
  static spinlock_t mtdblks_lock;
  
! static int mtd_sizes[MAX_MTD_DEVICES];
  static int mtd_blksizes[MAX_MTD_DEVICES];
  
  #if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,14)
--- 57,63 ----
  
  static spinlock_t mtdblks_lock;
  
! static sector_t mtd_sizes[MAX_MTD_DEVICES];
  static int mtd_blksizes[MAX_MTD_DEVICES];
  
  #if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,14)
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/mtd/nftlcore.c linux-2.4.22-ashuariadevel/drivers/mtd/nftlcore.c
*** linux-2.4.22-ashuariadevel.backup/drivers/mtd/nftlcore.c	2003-06-13 23:51:34.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/mtd/nftlcore.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 54,60 ****
   *  encountered, except ...
   */
  
! static int nftl_sizes[256];
  static int nftl_blocksizes[256];
  
  /* .. for the Linux partition table handling. */
--- 54,60 ----
   *  encountered, except ...
   */
  
! static sector_t nftl_sizes[256];
  static int nftl_blocksizes[256];
  
  /* .. for the Linux partition table handling. */
***************
*** 885,891 ****
  		DEBUG(MTD_DEBUG_LEVEL2, "NFTL_request\n");
  		DEBUG(MTD_DEBUG_LEVEL3, "NFTL %s request, from sector 0x%04lx for 0x%04lx sectors\n",
  		      (req->cmd == READ) ? "Read " : "Write",
! 		      req->sector, req->current_nr_sectors);
  
  		dev = MINOR(req->rq_dev);
  		block = req->sector;
--- 885,891 ----
  		DEBUG(MTD_DEBUG_LEVEL2, "NFTL_request\n");
  		DEBUG(MTD_DEBUG_LEVEL3, "NFTL %s request, from sector 0x%04lx for 0x%04lx sectors\n",
  		      (req->cmd == READ) ? "Read " : "Write",
! 		      (long)req->sector, req->current_nr_sectors);
  
  		dev = MINOR(req->rq_dev);
  		block = req->sector;
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/3w-xxxx.c linux-2.4.22-ashuariadevel/drivers/scsi/3w-xxxx.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/3w-xxxx.c	2003-08-25 20:44:42.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/3w-xxxx.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 2482,2493 ****
  
  	heads = 64;
  	sectors = 32;
! 	cylinders = disk->capacity / (heads * sectors);
  
  	if (disk->capacity >= 0x200000) {
  		heads = 255;
  		sectors = 63;
! 		cylinders = disk->capacity / (heads * sectors);
  	}
  
  	dprintk(KERN_NOTICE "3w-xxxx: tw_scsi_biosparam(): heads = %d, sectors = %d, cylinders = %d\n", heads, sectors, cylinders);
--- 2482,2493 ----
  
  	heads = 64;
  	sectors = 32;
! 	cylinders = (long)disk->capacity / (heads * sectors);
  
  	if (disk->capacity >= 0x200000) {
  		heads = 255;
  		sectors = 63;
! 		cylinders = (long)disk->capacity / (heads * sectors);
  	}
  
  	dprintk(KERN_NOTICE "3w-xxxx: tw_scsi_biosparam(): heads = %d, sectors = %d, cylinders = %d\n", heads, sectors, cylinders);
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/BusLogic.c linux-2.4.22-ashuariadevel/drivers/scsi/BusLogic.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/BusLogic.c	2001-12-22 02:41:55.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/BusLogic.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 4127,4133 ****
        DiskParameters->Sectors = 32;
      }
    DiskParameters->Cylinders =
!     Disk->capacity / (DiskParameters->Heads * DiskParameters->Sectors);
    /*
      Attempt to read the first 1024 bytes from the disk device.
    */
--- 4127,4133 ----
        DiskParameters->Sectors = 32;
      }
    DiskParameters->Cylinders =
! 	  (unsigned long)Disk->capacity / (DiskParameters->Heads * DiskParameters->Sectors);
    /*
      Attempt to read the first 1024 bytes from the disk device.
    */
***************
*** 4175,4181 ****
  	  PartitionEntryEndSector = FirstPartitionEntry->end_sector & 0x3F;
  	}
        DiskParameters->Cylinders =
! 	Disk->capacity / (DiskParameters->Heads * DiskParameters->Sectors);
        if (PartitionNumber < 4 &&
  	  PartitionEntryEndSector == DiskParameters->Sectors)
  	{
--- 4175,4181 ----
  	  PartitionEntryEndSector = FirstPartitionEntry->end_sector & 0x3F;
  	}
        DiskParameters->Cylinders =
! 	      (unsigned long)Disk->capacity / (DiskParameters->Heads * DiskParameters->Sectors);
        if (PartitionNumber < 4 &&
  	  PartitionEntryEndSector == DiskParameters->Sectors)
  	{
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/aacraid/linit.c linux-2.4.22-ashuariadevel/drivers/scsi/aacraid/linit.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/aacraid/linit.c	2003-12-09 11:52:13.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/aacraid/linit.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 453,459 ****
  		param->sectors = 32;
  	}
  
! 	param->cylinders = disk->capacity/(param->heads * param->sectors);
  
  	/*
  	 *	Read the first 1024 bytes from the disk device
--- 453,459 ----
  		param->sectors = 32;
  	}
  
! 	param->cylinders = (unsigned long)disk->capacity/(param->heads * param->sectors);
  
  	/*
  	 *	Read the first 1024 bytes from the disk device
***************
*** 508,514 ****
  			end_sec = first->end_sector & 0x3f;
  		}
  
! 		param->cylinders = disk->capacity / (param->heads * param->sectors);
  
  		if(num < 4 && end_sec == param->sectors)
  		{
--- 508,514 ----
  			end_sec = first->end_sector & 0x3f;
  		}
  
! 		param->cylinders = (unsigned long)disk->capacity / (param->heads * param->sectors);
  
  		if(num < 4 && end_sec == param->sectors)
  		{
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/advansys.c linux-2.4.22-ashuariadevel/drivers/scsi/advansys.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/advansys.c	2003-12-09 11:52:22.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/advansys.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 6218,6224 ****
                  ip[1] = 32;
          }
      }
!     ip[2] = dp->capacity / (ip[0] * ip[1]);
      ASC_DBG(1, "advansys_biosparam: end\n");
      return 0;
  }
--- 6218,6224 ----
                  ip[1] = 32;
          }
      }
!     ip[2] = (long)dp->capacity / (ip[0] * ip[1]);
      ASC_DBG(1, "advansys_biosparam: end\n");
      return 0;
  }
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/aha152x.c linux-2.4.22-ashuariadevel/drivers/scsi/aha152x.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/aha152x.c	2003-08-25 20:44:42.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/aha152x.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 1848,1854 ****
  	/* try default translation */
  	info_array[0] = 64;
  	info_array[1] = 32;
! 	info_array[2] = disk->capacity / (64 * 32);
  
  	/* for disks >1GB do some guessing */
  	if (info_array[2] >= 1024) {
--- 1848,1854 ----
  	/* try default translation */
  	info_array[0] = 64;
  	info_array[1] = 32;
! 	info_array[2] = (long)disk->capacity / (64 * 32);
  
  	/* for disks >1GB do some guessing */
  	if (info_array[2] >= 1024) {
***************
*** 1863,1869 ****
  				       "         using extended translation.\n");
  				info_array[0] = 255;
  				info_array[1] = 63;
! 				info_array[2] = disk->capacity / (255 * 63);
  			} else {
  				printk(KERN_NOTICE
  				       "aha152x: unable to verify geometry for disk with >1GB.\n"
--- 1863,1869 ----
  				       "         using extended translation.\n");
  				info_array[0] = 255;
  				info_array[1] = 63;
! 				info_array[2] = (long)disk->capacity / (255 * 63);
  			} else {
  				printk(KERN_NOTICE
  				       "aha152x: unable to verify geometry for disk with >1GB.\n"
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/aic7xxx_old.c linux-2.4.22-ashuariadevel/drivers/scsi/aic7xxx_old.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/aic7xxx_old.c	2003-06-13 23:51:36.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/aic7xxx_old.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 11752,11764 ****
    
    heads = 64;
    sectors = 32;
!   cylinders = disk->capacity / (heads * sectors);
  
    if ((p->flags & AHC_EXTEND_TRANS_A) && (cylinders > 1024))
    {
      heads = 255;
      sectors = 63;
!     cylinders = disk->capacity / (heads * sectors);
    }
  
    geom[0] = heads;
--- 11752,11764 ----
    
    heads = 64;
    sectors = 32;
!   cylinders = (long)disk->capacity / (heads * sectors);
  
    if ((p->flags & AHC_EXTEND_TRANS_A) && (cylinders > 1024))
    {
      heads = 255;
      sectors = 63;
!     cylinders = (long)disk->capacity / (heads * sectors);
    }
  
    geom[0] = heads;
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/atp870u.c linux-2.4.22-ashuariadevel/drivers/scsi/atp870u.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/atp870u.c	2002-08-03 09:39:44.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/atp870u.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 2850,2861 ****
  
  	heads = 64;
  	sectors = 32;
! 	cylinders = disk->capacity / (heads * sectors);
  
  	if (cylinders > 1024) {
  		heads = 255;
  		sectors = 63;
! 		cylinders = disk->capacity / (heads * sectors);
  	}
  	ip[0] = heads;
  	ip[1] = sectors;
--- 2850,2861 ----
  
  	heads = 64;
  	sectors = 32;
! 	cylinders = (long)disk->capacity / (heads * sectors);
  
  	if (cylinders > 1024) {
  		heads = 255;
  		sectors = 63;
! 		cylinders = (long)disk->capacity / (heads * sectors);
  	}
  	ip[0] = heads;
  	ip[1] = sectors;
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/dpt_i2o.c linux-2.4.22-ashuariadevel/drivers/scsi/dpt_i2o.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/dpt_i2o.c	2003-06-13 23:51:36.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/dpt_i2o.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 481,487 ****
  		heads = 255;
  		sectors = 63;
  	}
! 	cylinders = disk->capacity / (heads * sectors);
  
  	// Special case if CDROM
  	if(disk->device->type == 5) {  // CDROM
--- 481,487 ----
  		heads = 255;
  		sectors = 63;
  	}
! 	cylinders = (unsigned long)disk->capacity / (heads * sectors);
  
  	// Special case if CDROM
  	if(disk->device->type == 5) {  // CDROM
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/gdth.c linux-2.4.22-ashuariadevel/drivers/scsi/gdth.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/gdth.c	2003-08-25 20:44:42.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/gdth.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 4581,4587 ****
      } else {
          ip[0] = ha->hdr[t].heads;
          ip[1] = ha->hdr[t].secs;
!         ip[2] = disk->capacity / ip[0] / ip[1];
      }
  
      TRACE2(("gdth_bios_param(): %d heads, %d secs, %d cyls\n",
--- 4581,4587 ----
      } else {
          ip[0] = ha->hdr[t].heads;
          ip[1] = ha->hdr[t].secs;
!         ip[2] = (unsigned long)disk->capacity / ip[0] / ip[1];
      }
  
      TRACE2(("gdth_bios_param(): %d heads, %d secs, %d cyls\n",
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/ibmmca.c linux-2.4.22-ashuariadevel/drivers/scsi/ibmmca.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/ibmmca.c	2001-05-02 08:05:00.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/ibmmca.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 2386,2400 ****
  {
     info[0] = 64;
     info[1] = 32;
!    info[2] = disk->capacity / (info[0] * info[1]);
     if (info[2] >= 1024) {
        info[0] = 128;
        info[1] = 63;
!       info[2] = disk->capacity / (info[0] * info[1]);
        if (info[2] >= 1024) {
  	 info[0] = 255;
  	 info[1] = 63;
! 	 info[2] = disk->capacity / (info[0] * info[1]);
  	 if (info[2] >= 1024)
  	   info[2] = 1023;
        }
--- 2386,2400 ----
  {
     info[0] = 64;
     info[1] = 32;
!    info[2] = (long)disk->capacity / (info[0] * info[1]);
     if (info[2] >= 1024) {
        info[0] = 128;
        info[1] = 63;
!       info[2] = (long)disk->capacity / (info[0] * info[1]);
        if (info[2] >= 1024) {
  	 info[0] = 255;
  	 info[1] = 63;
! 	 info[2] = (long)disk->capacity / (info[0] * info[1]);
  	 if (info[2] >= 1024)
  	   info[2] = 1023;
        }
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/ide-scsi.c linux-2.4.22-ashuariadevel/drivers/scsi/ide-scsi.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/ide-scsi.c	2003-12-09 11:52:21.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/ide-scsi.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 580,593 ****
  /*
   *	idescsi_do_request is our request handling function.
   */
! static ide_startstop_t idescsi_do_request (ide_drive_t *drive, struct request *rq, unsigned long block)
  {
  #if IDESCSI_DEBUG_LOG
  	printk(KERN_INFO "rq_status: %d, rq_dev: %u, cmd: %d, errors: %d\n",
  		rq->rq_status, (unsigned int) rq->rq_dev, rq->cmd, rq->errors);
! 	printk(KERN_INFO "sector: %ld, nr_sectors: %ld, "
  		"current_nr_sectors: %ld\n", rq->sector,
! 		rq->nr_sectors, rq->current_nr_sectors);
  #endif /* IDESCSI_DEBUG_LOG */
  
  	if (rq->cmd == IDESCSI_PC_RQ) {
--- 580,593 ----
  /*
   *	idescsi_do_request is our request handling function.
   */
! static ide_startstop_t idescsi_do_request (ide_drive_t *drive, struct request *rq, sector_t block)
  {
  #if IDESCSI_DEBUG_LOG
  	printk(KERN_INFO "rq_status: %d, rq_dev: %u, cmd: %d, errors: %d\n",
  		rq->rq_status, (unsigned int) rq->rq_dev, rq->cmd, rq->errors);
! 	printk(KERN_INFO "sector: %llu, nr_sectors: %ld, "
  		"current_nr_sectors: %ld\n", rq->sector,
! 		(unsigned long long)rq->nr_sectors, rq->current_nr_sectors);
  #endif /* IDESCSI_DEBUG_LOG */
  
  	if (rq->cmd == IDESCSI_PC_RQ) {
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/imm.c linux-2.4.22-ashuariadevel/drivers/scsi/imm.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/imm.c	2003-12-09 11:52:22.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/imm.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 1129,1139 ****
  {
      ip[0] = 0x40;
      ip[1] = 0x20;
!     ip[2] = (disk->capacity + 1) / (ip[0] * ip[1]);
      if (ip[2] > 1024) {
  	ip[0] = 0xff;
  	ip[1] = 0x3f;
! 	ip[2] = (disk->capacity + 1) / (ip[0] * ip[1]);
      }
      return 0;
  }
--- 1129,1139 ----
  {
      ip[0] = 0x40;
      ip[1] = 0x20;
!     ip[2] = ((long)disk->capacity + 1) / (ip[0] * ip[1]);
      if (ip[2] > 1024) {
  	ip[0] = 0xff;
  	ip[1] = 0x3f;
! 	ip[2] = ((long)disk->capacity + 1) / (ip[0] * ip[1]);
      }
      return 0;
  }
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/in2000.c linux-2.4.22-ashuariadevel/drivers/scsi/in2000.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/in2000.c	2003-06-13 23:51:36.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/in2000.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 2174,2190 ****
     if (iinfo[2] > 1024) {
        iinfo[0] = 64;
        iinfo[1] = 63;
!       iinfo[2] = disk->capacity / (iinfo[0] * iinfo[1]);
        }
     if (iinfo[2] > 1024) {
        iinfo[0] = 128;
        iinfo[1] = 63;
!       iinfo[2] = disk->capacity / (iinfo[0] * iinfo[1]);
        }
     if (iinfo[2] > 1024) {
        iinfo[0] = 255;
        iinfo[1] = 63;
!       iinfo[2] = disk->capacity / (iinfo[0] * iinfo[1]);
        }
      return 0;
  }
--- 2174,2190 ----
     if (iinfo[2] > 1024) {
        iinfo[0] = 64;
        iinfo[1] = 63;
!       iinfo[2] = (long)disk->capacity / (iinfo[0] * iinfo[1]);
        }
     if (iinfo[2] > 1024) {
        iinfo[0] = 128;
        iinfo[1] = 63;
!       iinfo[2] = (long)disk->capacity / (iinfo[0] * iinfo[1]);
        }
     if (iinfo[2] > 1024) {
        iinfo[0] = 255;
        iinfo[1] = 63;
!       iinfo[2] = (long)disk->capacity / (iinfo[0] * iinfo[1]);
        }
      return 0;
  }
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/ini9100u.c linux-2.4.22-ashuariadevel/drivers/scsi/ini9100u.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/ini9100u.c	2001-10-01 04:26:07.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/ini9100u.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 592,607 ****
  	if (pTcb->TCS_DrvHead) {
  		info_array[0] = pTcb->TCS_DrvHead;
  		info_array[1] = pTcb->TCS_DrvSector;
! 		info_array[2] = disk->capacity / pTcb->TCS_DrvHead / pTcb->TCS_DrvSector;
  	} else {
  		if (pTcb->TCS_DrvFlags & TCF_DRV_255_63) {
  			info_array[0] = 255;
  			info_array[1] = 63;
! 			info_array[2] = disk->capacity / 255 / 63;
  		} else {
  			info_array[0] = 64;
  			info_array[1] = 32;
! 			info_array[2] = disk->capacity >> 11;
  		}
  	}
  
--- 592,607 ----
  	if (pTcb->TCS_DrvHead) {
  		info_array[0] = pTcb->TCS_DrvHead;
  		info_array[1] = pTcb->TCS_DrvSector;
! 		info_array[2] = (long)disk->capacity / pTcb->TCS_DrvHead / pTcb->TCS_DrvSector;
  	} else {
  		if (pTcb->TCS_DrvFlags & TCF_DRV_255_63) {
  			info_array[0] = 255;
  			info_array[1] = 63;
! 			info_array[2] = (long)disk->capacity / 255 / 63;
  		} else {
  			info_array[0] = 64;
  			info_array[1] = 32;
! 			info_array[2] = (long)disk->capacity >> 11;
  		}
  	}
  
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/inia100.c linux-2.4.22-ashuariadevel/drivers/scsi/inia100.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/inia100.c	2001-10-01 04:26:07.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/inia100.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 701,716 ****
  	if (pTcb->TCS_DrvHead) {
  		info_array[0] = pTcb->TCS_DrvHead;
  		info_array[1] = pTcb->TCS_DrvSector;
! 		info_array[2] = disk->capacity / pTcb->TCS_DrvHead / pTcb->TCS_DrvSector;
  	} else {
  		if (pTcb->TCS_DrvFlags & TCF_DRV_255_63) {
  			info_array[0] = 255;
  			info_array[1] = 63;
! 			info_array[2] = disk->capacity / 255 / 63;
  		} else {
  			info_array[0] = 64;
  			info_array[1] = 32;
! 			info_array[2] = disk->capacity >> 11;
  		}
  	}
  	return 0;
--- 701,716 ----
  	if (pTcb->TCS_DrvHead) {
  		info_array[0] = pTcb->TCS_DrvHead;
  		info_array[1] = pTcb->TCS_DrvSector;
! 		info_array[2] = (long)disk->capacity / pTcb->TCS_DrvHead / pTcb->TCS_DrvSector;
  	} else {
  		if (pTcb->TCS_DrvFlags & TCF_DRV_255_63) {
  			info_array[0] = 255;
  			info_array[1] = 63;
! 			info_array[2] = (long)disk->capacity / 255 / 63;
  		} else {
  			info_array[0] = 64;
  			info_array[1] = 32;
! 			info_array[2] = (long)disk->capacity >> 11;
  		}
  	}
  	return 0;
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/ips.c linux-2.4.22-ashuariadevel/drivers/scsi/ips.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/ips.c	2003-12-09 11:52:13.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/ips.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 1180,1186 ****
  		sectors = IPS_COMP_SECTORS;
  	}
  
! 	cylinders = disk->capacity / (heads * sectors);
  
  	DEBUG_VAR(2, "Geometry: heads: %d, sectors: %d, cylinders: %d",
  		  heads, sectors, cylinders);
--- 1180,1186 ----
  		sectors = IPS_COMP_SECTORS;
  	}
  
! 	cylinders = (long)disk->capacity / (heads * sectors);
  
  	DEBUG_VAR(2, "Geometry: heads: %d, sectors: %d, cylinders: %d",
  		  heads, sectors, cylinders);
***************
*** 7292,7298 ****
  	 * are guaranteed to be < 4G.
  	 */
  	if (IPS_ENABLE_DMA64 && IPS_HAS_ENH_SGLIST(ha) &&
! 	    !pci_set_dma_mask(ha->pcidev, (u64) 0xffffffffffffffff)) {
  		(ha)->flags |= IPS_HA_ENH_SG;
  	} else {
  		if (pci_set_dma_mask(ha->pcidev, (u64) 0xffffffff) != 0) {
--- 7292,7298 ----
  	 * are guaranteed to be < 4G.
  	 */
  	if (IPS_ENABLE_DMA64 && IPS_HAS_ENH_SGLIST(ha) &&
! 	    !pci_set_dma_mask(ha->pcidev, (u64) 0xffffffffffffffffULL)) {
  		(ha)->flags |= IPS_HA_ENH_SG;
  	} else {
  		if (pci_set_dma_mask(ha->pcidev, (u64) 0xffffffff) != 0) {
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/megaraid.c linux-2.4.22-ashuariadevel/drivers/scsi/megaraid.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/megaraid.c	2003-08-25 20:44:42.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/megaraid.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 4397,4402 ****
--- 4397,4403 ----
  int megaraid_biosparam (Disk * disk, kdev_t dev, int *geom)
  {
  	int heads, sectors, cylinders;
+ 	unsigned long capacity = (unsigned long)disk->capacity;
  	mega_host_config *megaCfg;
  
  	/* Get pointer to host config structure */
***************
*** 4406,4418 ****
  			/* Default heads (64) & sectors (32) */
  			heads = 64;
  			sectors = 32;
! 			cylinders = disk->capacity / (heads * sectors);
  
  			/* Handle extended translation size for logical drives > 1Gb */
! 			if (disk->capacity >= 0x200000) {
  				heads = 255;
  				sectors = 63;
! 				cylinders = disk->capacity / (heads * sectors);
  			}
  
  			/* return result */
--- 4407,4419 ----
  			/* Default heads (64) & sectors (32) */
  			heads = 64;
  			sectors = 32;
! 			cylinders = capacity / (heads * sectors);
  
  			/* Handle extended translation size for logical drives > 1Gb */
! 			if (capacity >= 0x200000) {
  				heads = 255;
  				sectors = 63;
! 				cylinders = capacity / (heads * sectors);
  			}
  
  			/* return result */
***************
*** 4430,4442 ****
  		/* Default heads (64) & sectors (32) */
  		heads = 64;
  		sectors = 32;
! 		cylinders = disk->capacity / (heads * sectors);
  
  		/* Handle extended translation size for logical drives > 1Gb */
! 		if (disk->capacity >= 0x200000) {
  			heads = 255;
  			sectors = 63;
! 			cylinders = disk->capacity / (heads * sectors);
  		}
  
  		/* return result */
--- 4431,4443 ----
  		/* Default heads (64) & sectors (32) */
  		heads = 64;
  		sectors = 32;
! 		cylinders = capacity / (heads * sectors);
  
  		/* Handle extended translation size for logical drives > 1Gb */
! 		if (capacity >= 0x200000) {
  			heads = 255;
  			sectors = 63;
! 			cylinders = capacity / (heads * sectors);
  		}
  
  		/* return result */
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/megaraid2.c linux-2.4.22-ashuariadevel/drivers/scsi/megaraid2.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/megaraid2.c	2003-12-09 11:52:13.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/megaraid2.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 3839,3844 ****
--- 3839,3845 ----
  megaraid_biosparam(Disk *disk, kdev_t dev, int *geom)
  {
  	int heads, sectors, cylinders;
+ 	unsigned long capacity = (unsigned long)disk->capacity;
  	adapter_t *adapter;
  
  	/* Get pointer to host config structure */
***************
*** 3848,3863 ****
  			/* Default heads (64) & sectors (32) */
  			heads = 64;
  			sectors = 32;
! 			cylinders = disk->capacity / (heads * sectors);
  
  			/*
  			 * Handle extended translation size for logical drives
  			 * > 1Gb
  			 */
! 			if (disk->capacity >= 0x200000) {
  				heads = 255;
  				sectors = 63;
! 				cylinders = disk->capacity / (heads * sectors);
  			}
  
  			/* return result */
--- 3849,3864 ----
  			/* Default heads (64) & sectors (32) */
  			heads = 64;
  			sectors = 32;
! 			cylinders = capacity / (heads * sectors);
  
  			/*
  			 * Handle extended translation size for logical drives
  			 * > 1Gb
  			 */
! 			if (capacity >= 0x200000) {
  				heads = 255;
  				sectors = 63;
! 				cylinders = capacity / (heads * sectors);
  			}
  
  			/* return result */
***************
*** 3876,3888 ****
  		/* Default heads (64) & sectors (32) */
  		heads = 64;
  		sectors = 32;
! 		cylinders = disk->capacity / (heads * sectors);
  
  		/* Handle extended translation size for logical drives > 1Gb */
! 		if (disk->capacity >= 0x200000) {
  			heads = 255;
  			sectors = 63;
! 			cylinders = disk->capacity / (heads * sectors);
  		}
  
  		/* return result */
--- 3877,3889 ----
  		/* Default heads (64) & sectors (32) */
  		heads = 64;
  		sectors = 32;
! 		cylinders = capacity / (heads * sectors);
  
  		/* Handle extended translation size for logical drives > 1Gb */
! 		if (capacity >= 0x200000) {
  			heads = 255;
  			sectors = 63;
! 			cylinders = capacity / (heads * sectors);
  		}
  
  		/* return result */
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/ppa.c linux-2.4.22-ashuariadevel/drivers/scsi/ppa.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/ppa.c	2003-12-09 11:52:22.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/ppa.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 1004,1014 ****
  {
      ip[0] = 0x40;
      ip[1] = 0x20;
!     ip[2] = (disk->capacity + 1) / (ip[0] * ip[1]);
      if (ip[2] > 1024) {
  	ip[0] = 0xff;
  	ip[1] = 0x3f;
! 	ip[2] = (disk->capacity + 1) / (ip[0] * ip[1]);
  	if (ip[2] > 1023)
  	    ip[2] = 1023;
      }
--- 1004,1014 ----
  {
      ip[0] = 0x40;
      ip[1] = 0x20;
!     ip[2] = ((long)disk->capacity + 1) / (ip[0] * ip[1]);
      if (ip[2] > 1024) {
  	ip[0] = 0xff;
  	ip[1] = 0x3f;
! 	ip[2] = ((long)disk->capacity + 1) / (ip[0] * ip[1]);
  	if (ip[2] > 1023)
  	    ip[2] = 1023;
      }
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/scsi/qlogicfas.c linux-2.4.22-ashuariadevel/drivers/scsi/qlogicfas.c
*** linux-2.4.22-ashuariadevel.backup/drivers/scsi/qlogicfas.c	2003-06-13 23:51:36.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/scsi/qlogicfas.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 678,688 ****
  /* This should mimic the DOS Qlogic driver's behavior exactly */
  	ip[0] = 0x40;
  	ip[1] = 0x20;
! 	ip[2] = disk->capacity / (ip[0] * ip[1]);
  	if (ip[2] > 1024) {
  		ip[0] = 0xff;
  		ip[1] = 0x3f;
! 		ip[2] = disk->capacity / (ip[0] * ip[1]);
  #if 0
  		if (ip[2] > 1023)
  			ip[2] = 1023;
--- 678,688 ----
  /* This should mimic the DOS Qlogic driver's behavior exactly */
  	ip[0] = 0x40;
  	ip[1] = 0x20;
! 	ip[2] = (long)disk->capacity / (ip[0] * ip[1]);
  	if (ip[2] > 1024) {
  		ip[0] = 0xff;
  		ip[1] = 0x3f;
! 		ip[2] = (long)disk->capacity / (ip[0] * ip[1]);
  #if 0
  		if (ip[2] > 1023)
  			ip[2] = 1023;
